S3QLLOCK(1)

NAME
s3qllock - Make trees on an S3QL file system immutable

SYNOPSIS

s3qllock [options] <directory>

DESCRIPTION

S3QL is a file system for online data storage. Before using S3QL, make sure to consult the full documentation (rather than just the man pages which only briefly document the available userspace commands).

The s3qllock command makes a directory tree in an S3QL file system immutable. Immutable trees can no longer be changed in any way whatsoever. You can not add new files or directories and you can not change or delete existing files and directories. The only way to get rid of an immutable tree is to use the s3qlrm command.

s3qllock can only be called by the user that mounted the file system and (if the file system was mounted with --allow-other or --allow-root) the root user.

RATIONALE

Immutability is a feature designed for backups. Traditionally, backups have been made on external tape drives. Once a backup was made, the tape drive was removed and locked somewhere in a shelf. This has the great advantage that the contents of the backup are now permanently fixed. Nothing (short of physical destruction) can change or delete files in the backup.

In contrast, when backing up into an online storage system like S3QL, all backups are available every time the file system is mounted. Nothing prevents a file in an old backup from being changed again later on. In the worst case, this may make your entire backup system worthless. Imagine that your system gets infected by a nasty virus that simply deletes all files it can find -- if the virus is active while the backup file system is mounted, the virus will destroy all your old backups as well!

Even if the possibility of a malicious virus or trojan horse is excluded, being able to change a backup after it has been made is generally not a good idea. A common S3QL use case is to keep the file system mounted at all times and periodically create backups with rsync -a. This allows every user to recover her files from a backup without having to call the system administrator. However, this also allows every user to accidentally change or delete files in one of the old backups.

Making a backup immutable protects you against all these problems. Unless you happen to run into a virus that was specifically programmed to attack S3QL file systems, backups can be neither deleted nor changed after they have been made immutable.

OPTIONS

The s3qllock command accepts the following options:

--debug-modules <modules>
    Activate debugging output from specified modules (use commas to separate multiple modules). Debug messages will be written to the target specified by the --log option.

--debug
    Activate debugging output from all S3QL modules. Debug messages will be written to the target specified by the --log option.

--quiet
    be really quiet

--version
    just print program version and exit

EXIT CODES

s3qllock may terminate with the following exit codes:

0   Everything went well.

1   An unexpected error occured. This may indicate a bug in the program.

2   Invalid command line argument.

SEE ALSO

The S3QL homepage is at https://bitbucket.org/nikratio/s3ql/.

The full S3QL documentation should also be installed somewhere on your system, common locations are /usr/share/doc/s3ql or /usr/local/doc/s3ql.

COPYRIGHT
© 2008 Nikolaus Rath <Nikolaus@rath.org>